/* Bestehende Primflag-Datei erweitern */

#include <stdio.h>
#include <ctype.h>
#include <malloc.h>

#define STDGR 100000ul

/* Globale Variablen */
unsigned long int bisher, anzahl = (STDGR - 1) / 32 + 1;
unsigned int _huge *primflag;
FILE *datei;

int sieve(void);


main(int argc, char *argv[])
{ char *primfile;
  unsigned long int i;
  int ret = 0;

  puts("PRIMEXTD 1.0 - Erweitert primre Primzahlendatei"
                     " (c) 1995 Heinz Repp");
  switch (argc)
  { case 3:
      sscanf(argv[2], "%lu", &anzahl);
      anzahl = (anzahl - 1) / 32 + 1;
    case 2:
      primfile = argv[1];
      break;
    default:
      puts("Syntax: primextd <Datei> [<Bereich>]");
      exit(-1);
  } /* Kommandozeile */

  if ((datei = fopen(primfile, "rb+")) == NULL)
  { printf("Fehler: kann Datei %s nicht ffnen.\n", primfile);
    exit(-3);
  } /* Datei zum Lesen und Schreiben am Anfang geffnet */

  for (i = 4; i; i--)
  { if (getw(datei))
    { puts("Lesefehler oder Dateioffset nicht 0.");
      ret = -6;
      goto abbruch2;
    } /* mssen 0 sein: */
  } /* die ersten 4 Worte */

  fseek(datei, 0l, SEEK_END);  /* Dateilnge bestimmen */
  bisher = (ftell(datei) >> 1) - 4; /* Lnge gespeichertes Feldes */
  fseek(datei, 8l, SEEK_SET);  /* etwas umstndlich */

  if (bisher < 65536ul & anzahl > (bisher - 1) * bisher)
  { puts("\nGewnschter Bereich grer als durch bestehenden mglich.");
    anzahl = (bisher - 1) * bisher;
    printf("Er wurde auf %lu begrenzt.\n", anzahl << 5);
  } /* Bereichsbegrenzung */

  if ((primflag = halloc(anzahl, sizeof(int))) == NULL)
  { printf("Ungengend Speicher fr %lu ", anzahl * 32);
    puts(" - Programm beendet.");
    ret = -2;
    goto abbruch2;
  } /* dynamisches Huge-Feld zugeordnet */

  if (ret = sieve())
    goto abbruch1;

  fflush(datei);  /* umschalten auf Schreiben */
  fseek(datei, 0l, SEEK_END);

  for (i = 0; i < anzahl; )
  { putw(primflag[i++], datei);
    if (ferror(datei))
    { printf("\nFehler beim Erweitern von %s:\n", primfile);
      puts("z.B. Datentrger voll oder Datei schreibgeschtzt?");
      ret = -5;
      break;
    } /* Schreibfehler */
  } /* Feld gespeichert */

abbruch1:
  hfree(primflag);
abbruch2:
  fclose(datei);
  exit(ret);
} /* main */


int sieve(void)
{ unsigned long int i, prim, zahl, ende;
  unsigned int j, count, flagwort;

  printf("rechne ");
  /* Flagfeld mit Einsen initialisieren */
  for (i = 0; i < anzahl; primflag[i++] = ~0u)
    ;

  zahl = (anzahl + bisher) >> 6;
  do
  { ende = zahl;
    zahl = (((anzahl + bisher) >> 5) / ende + ende) / 2;
  } while (ende > zahl);

  count = 1;        /* so gibts gleich einen Punkt */
  for (i = 0; i <= ende; i++)
  { flagwort = getw(datei);

    if (feof(datei))
    { puts("\nunerwartetes Dateiende - Programm abgebrochen.");
      return -7;
    } /* EOF */

    if (ferror(datei))
    { puts("\nLesefehler - Programm abgebrochen.");
      return -4;
    } /* ferror */

    if (--count == 0)
    { putchar('.');
      count = i * ende / (40 * i + ende + 1) + 1;
    } /* einen Punkt ausgeben */

    for (j = 0; j < 16; j++)
    { if (flagwort & (1u << j))
      { zahl = (i << 4) + j;
        prim = (zahl << 1) + 1;  /* jede 2. berspringen */
        zahl = prim - 1 - ((bisher << 4) + zahl) % prim;
        while (zahl < (anzahl << 4))
        { primflag[zahl >> 4] &= ~(1 << (zahl&15));
          zahl += prim;
        } /* Lschschleife */
      } /* endif Bit gesetzt */
    } /* Bitschleife */

  } /* Wortschleife */
  puts(" fertig.");
  return 0;
} /* sieve */
